package cn.wustlinghang.wusthelper.internal.graduate.api.http.v1;

import cn.wustlinghang.wusthelper.internal.graduate.services.LoginService;
import cn.wustlinghang.wusthelper.internal.rpc.exception.RpcException;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

@Path("/cookie")
public class CookieApi {
    private final LoginService loginService;

    public CookieApi(LoginService loginService) {
        this.loginService = loginService;
    }

    @GET
    @Path("/")
    public String login(@QueryParam("username") @NotNull String username,
                        @QueryParam("password") @NotNull String password) throws RpcException {
        return loginService.login(username, password);
    }

    @GET
    @Path("/verify")
    public Boolean verify(@QueryParam("cookie") @NotNull String cookie) throws RpcException {
        return loginService.verify(cookie);
    }
}
