package cn.wustlinghang.wusthelper.internal.library.api.http.v1;

import cn.wustlinghang.wusthelper.internal.library.services.BookCoverImageUrlService;
import cn.wustlinghang.wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

@Path("/cover_image")
@ApplicationScoped
public class BookCoverImageApi {
    private final BookCoverImageUrlService service;

    public BookCoverImageApi(BookCoverImageUrlService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public Object get(@QueryParam("isbn") @NotNull String isbn)
            throws RpcException {
        if (isbn.contains(",")) {
            return this.batch(isbn);
        } else {
            return this.agent(isbn);
        }
    }

    @GET
    @Path("/agent")
    public List<String> agent(@QueryParam("isbn") @NotNull String isbn)
            throws RpcException {
        return service.getBookCoverImageUrl(isbn);
    }

    @GET
    @Path("/batch")
    public Map<String, List<String>> batch(@QueryParam("isbn") @NotNull String isbn)
            throws RpcException {
        return service.getBookCoverImageUrl(Arrays.stream(isbn.split(",")).toList());
    }
}
