package cn.wustlinghang.wusthelper.internal.library.api.http.v1;

import cn.wustlinghang.mywust.data.library.parsed.BookDetail;
import cn.wustlinghang.wusthelper.internal.library.services.BookDetailService;
import cn.wustlinghang.wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

@Path("/book_detail")
@ApplicationScoped
public class BookDetailApi {
    private final BookDetailService service;

    public BookDetailApi(BookDetailService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public BookDetail get(@QueryParam("id") @NotNull String id)
            throws RpcException {
        return this.agent(id);
    }

    @GET
    @Path("/agent")
    public BookDetail agent(@QueryParam("id") @NotNull String id)
            throws RpcException {
        return service.getBookDetail(id);
    }
}
