package cn.wustlinghang.wusthelper.internal.library.api.http.v1;

import cn.wustlinghang.mywust.data.library.PagingResult;
import cn.wustlinghang.mywust.data.library.origin.CurrentLoanBook;
import cn.wustlinghang.wusthelper.internal.library.services.CurrentLoanService;
import cn.wustlinghang.wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.DefaultValue;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/current_loan")
@ApplicationScoped
public class CurrentLoanApi {
    private final CurrentLoanService service;

    public CurrentLoanApi(CurrentLoanService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public PagingResult<List<CurrentLoanBook>> get(@QueryParam("cookie") @NotNull String cookie,
                                                   @DefaultValue("1") @QueryParam("page") int page,
                                                   @DefaultValue("100") @QueryParam("page_size") int pageSize
    ) throws RpcException {
        return this.agent(cookie, page, pageSize);
    }

    @GET
    @Path("/agent")
    public PagingResult<List<CurrentLoanBook>> agent(@QueryParam("cookie") @NotNull String cookie,
                                                     @DefaultValue("1") @QueryParam("page") int page,
                                                     @DefaultValue("100") @QueryParam("page_size") int pageSize
    ) throws RpcException {
        return service.getCurrentLoan(cookie, page, pageSize);
    }
}
