package cn.wustlinghang.wusthelper.internal.library.api.http.v1;

import cn.wustlinghang.mywust.data.library.PagingResult;
import cn.wustlinghang.mywust.data.library.origin.HistoryLoanBook;
import cn.wustlinghang.wusthelper.internal.library.services.LoanHistoryService;
import cn.wustlinghang.wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.DefaultValue;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/loan_history")
@ApplicationScoped
public class LoanHistoryApi {
    private final LoanHistoryService service;

    public LoanHistoryApi(LoanHistoryService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public PagingResult<List<HistoryLoanBook>> get(@QueryParam("cookie") @NotNull String cookie,
                                                   @DefaultValue("1") @QueryParam("page") int page,
                                                   @DefaultValue("100") @QueryParam("page_size") int pageSize
    ) throws RpcException {
        return this.agent(cookie, page, pageSize);
    }

    @GET
    @Path("/agent")
    public PagingResult<List<HistoryLoanBook>> agent(@QueryParam("cookie") @NotNull String cookie,
                                                  @DefaultValue("1") @QueryParam("page") int page,
                                                  @DefaultValue("100") @QueryParam("page_size") int pageSize
    ) throws RpcException {
        return service.getLoanHistory(cookie, page, pageSize);
    }
}
