package cn.wustlinghang.wusthelper.internal.library.api.http.v1;

import cn.wustlinghang.mywust.data.library.PagingResult;
import cn.wustlinghang.mywust.data.library.origin.BaseLoanBook;
import cn.wustlinghang.wusthelper.internal.library.services.OverdueSoonService;
import cn.wustlinghang.wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.DefaultValue;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/overdue_soon")
@ApplicationScoped
public class OverdueSoonApi {
    private final OverdueSoonService service;

    public OverdueSoonApi(OverdueSoonService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public PagingResult<List<BaseLoanBook>> get(@QueryParam("cookie") @NotNull String cookie,
                                                @DefaultValue("1") @QueryParam("page") int page,
                                                @DefaultValue("100") @QueryParam("page_size") int pageSize
    ) throws RpcException {
        return this.agent(cookie, page, pageSize);
    }

    @GET
    @Path("/agent")
    public PagingResult<List<BaseLoanBook>> agent(@QueryParam("cookie") @NotNull String cookie,
                                                  @DefaultValue("1") @QueryParam("page") int page,
                                                  @DefaultValue("100") @QueryParam("page_size") int pageSize
    ) throws RpcException {
        return service.getOverdueSoon(cookie, page, pageSize);
    }
}
