package cn.wustlinghang.wusthelper.internal.library.api.http.v1.handler;

import cn.wustlinghang.wusthelper.internal.rpc.response.RpcCommonResponseCode;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;
import lombok.extern.slf4j.Slf4j;

import java.io.IOException;

@Slf4j
@Provider
public class IOExceptionHandler extends BaseExceptionHandler implements ExceptionMapper<IOException> {
    @Override
    public Response toResponse(IOException e) {
        log.error("IO异常：", e);
        return super.toResponse(
                RpcCommonResponseCode.SERVER_INTERNAL_ERROR,
                e.toString(),
                "IOExceptionHandler"
        );
    }
}
