package cn.wustlinghang.wusthelper.internal.library.api.http.v1.handler;

import cn.wustlinghang.wusthelper.internal.rpc.exception.LibraryRpcException;
import cn.wustlinghang.wusthelper.internal.rpc.exception.RpcException;
import jakarta.ws.rs.WebApplicationException;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;

@Provider
public class WebApplicationExceptionHandler extends BaseExceptionHandler implements ExceptionMapper<WebApplicationException> {
    @Override
    public Response toResponse(WebApplicationException e) {
        return super.toResponse(
                e.getResponse().getStatus(),
                RpcException.toIntCode(
                        LibraryRpcException.LIBRARY_MODULE,
                        LibraryRpcException.SubModuleCode.COMMON.ordinal(),
                        LibraryRpcException.TypeCode.OTHER_EXCEPTION.ordinal() * 100
                                + LibraryRpcException.ErrorCode.REQUEST_INVALID.ordinal()
                ),
                e.getMessage(),
                "WebApplicationExceptionHandler"
        );
    }
}
