package cn.wustlinghang.wusthelper.internal.library.bean;

import cn.wustlinghang.mywust.core.request.service.auth.LibraryLogin;
import cn.wustlinghang.mywust.core.request.service.library.*;
import cn.wustlinghang.mywust.network.RequestClientOption;
import cn.wustlinghang.mywust.network.Requester;
import cn.wustlinghang.mywust.network.okhttp.SimpleOkhttpRequester;
import jakarta.inject.Singleton;

public class MywustRequestAgentBeans {

    @Singleton
    public RequestClientOption requestClientOption() {
        RequestClientOption.Proxy proxy = RequestClientOption.Proxy.builder()
                .address("127.0.0.1")
                .port(8080)
                .build();
        RequestClientOption option = new RequestClientOption();
//        option.setProxy(proxy);

        return option;
    }

    @Singleton
    public Requester requester(RequestClientOption option) {
        return new SimpleOkhttpRequester(option, true);
    }

    @Singleton
    public LibraryLogin libraryLogin(Requester requester) {
        return new LibraryLogin(requester);
    }

    @Singleton
    public BookCoverImageUrlApiService bookCoverImageUrlApiService(Requester requester) {
        return new BookCoverImageUrlApiService(requester);
    }

    @Singleton
    public BookDetailApiService bookDetailApiService(Requester requester) {
        return new BookDetailApiService(requester);
    }

    @Singleton
    public BookHoldingApiService bookHoldingApiService(Requester requester) {
        return new BookHoldingApiService(requester);
    }

    @Singleton
    public CurrentLoanApiService currentLoanApiService(Requester requester) {
        return new CurrentLoanApiService(requester);
    }

    @Singleton
    public LoanHistoryApiService loanHistoryApiService(Requester requester) {
        return new LoanHistoryApiService(requester);
    }

    @Singleton
    public OverdueSoonApiService overdueSoonApiService(Requester requester) {
        return new OverdueSoonApiService(requester);
    }

    @Singleton
    public  SearchApiService searchApiService(Requester requester) {
        return new SearchApiService(requester);
    }
}