package cn.wustlinghang.wusthelper.internal.library.services;

import cn.wustlinghang.mywust.core.request.service.library.BookHoldingApiService;
import cn.wustlinghang.mywust.data.library.parsed.BookHolding;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import cn.wustlinghang.wusthelper.internal.rpc.exception.LibraryRpcException;
import cn.wustlinghang.wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;

import java.io.IOException;
import java.util.List;

@ApplicationScoped
public class BookHoldingService extends BaseService {
    private final BookHoldingApiService api;

    public BookHoldingService(BookHoldingApiService api) {
        this.api = api;
    }

    public List<BookHolding> getHoldings(String id)
            throws RpcException {
        try {
            return api.getHoldingList(id);
        } catch (ApiException e) {
            throw wrapApiException(e, LibraryRpcException.SubModuleCode.BOOK_HOLDING);
        } catch (IOException e) {
            throw new LibraryRpcException(
                    LibraryRpcException.TypeCode.NETWORK_EXCEPTION,
                    LibraryRpcException.SubModuleCode.BOOK_HOLDING,
                    LibraryRpcException.ErrorCode.NETWORK_ERROR
            );
        } catch (ParseException e) {
            throw new LibraryRpcException(
                    LibraryRpcException.TypeCode.PARSE_EXCEPTION,
                    LibraryRpcException.SubModuleCode.BOOK_HOLDING,
                    LibraryRpcException.ErrorCode.PARSE_ERROR
            );
        }
    }
}
