package cn.wustlinghang.wusthelper.internal.physics.api.http.v1;

import cn.wustlinghang.mywust.data.physics.PhysicsCourse;
import cn.wustlinghang.wusthelper.internal.physics.services.CourseTableService;
import cn.wustlinghang.wusthelper.internal.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/course_table")
@ApplicationScoped
public class CourseTableApi {
    private final CourseTableService service;

    public CourseTableApi(CourseTableService service) {
        this.service = service;
    }

    @GET
    @Path("/")
    public List<PhysicsCourse> get(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return this.parse(this.agent(cookie));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return service.getCourseTable(cookie);
    }

    @POST
    @Path("/parse")
    public List<PhysicsCourse> parse(String html) throws RpcException {
        return service.parseCourseTable(html);
    }
}
