package cn.wustlinghang.wusthelper.internal.undergrad.bean;

import cn.wustlinghang.mywust.core.request.service.auth.UndergraduateLogin;
import cn.wustlinghang.mywust.core.request.service.undergraduate.*;
import cn.wustlinghang.mywust.network.RequestClientOption;
import cn.wustlinghang.mywust.network.Requester;
import cn.wustlinghang.mywust.network.okhttp.SimpleOkhttpRequester;
import jakarta.inject.Singleton;

public class MywustRequestAgentBeans {

    @Singleton
    public RequestClientOption requestClientOption() {
        RequestClientOption.Proxy proxy = RequestClientOption.Proxy.builder()
                .address("127.0.0.1")
                .port(8080)
                .build();
        RequestClientOption option = new RequestClientOption();
//        option.setProxy(proxy);

        return option;
    }

    @Singleton
    public Requester requester(RequestClientOption option) {
        return new SimpleOkhttpRequester(option, true);
    }

    @Singleton
    public UndergraduateLogin undergraduateLogin(Requester requester) {
        return new UndergraduateLogin(requester);
    }

    @Singleton
    public UndergradCourseTableApiService undergradCourseTableApiService(Requester requester) {
        return new UndergradCourseTableApiService(requester);
    }

    @Singleton
    public UndergradScoreApiService undergradScoreApiService(Requester requester) {
        return new UndergradScoreApiService(requester);
    }

    @Singleton
    public UndergradStudentInfoApiService undergradStudentInfoApiService(Requester requester) {
        return new UndergradStudentInfoApiService(requester);
    }

    @Singleton
    public UndergradTrainingPlanApiService undergradTrainingPlanApiService(Requester requester) {
        return new UndergradTrainingPlanApiService(requester);
    }

    @Singleton
    public UndergradCreditStatusApiService undergradCreditStatusApiService(Requester requester) {
        return new UndergradCreditStatusApiService(requester);
    }

    @Singleton
    public UndergradExamDelayApiService undergradExamDelayApiService(Requester requester) {
        return new UndergradExamDelayApiService(requester);
    }
}